#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"

void gdMakeNote( gdImagePtr im, NOTE o, int color, int rcolor, int tcolor ){
  
  int i, x, y, rows, font_x, font_y, max = 0;

  x = o.posx;
  y = o.posy;

  max = 0;
  rows = 0;
  font_y = FONT->h;
  font_x = FONT->w;

  /* max = numbers of chars in the line with most chars */

  for( i = 0; strlen( o.txt[i] ) > 0; i++ ) {
    if( strlen( o.txt[i] ) > max )
      max = strlen( o.txt[i] );
    rows++;
  }

  /* if the note is out of bounds, don't draw it at all. */

  if ( gdImageBoundsSafe( im , x + font_x * ( max + 2 ), 
			  y + font_y * ( rows + 2 ) )) {
    
    /* left top corner -> right top corner */

    gdImageLine( im, x, y, x + font_x * ( max + 2 ), y, rcolor );

    /* right top corner -> rigt bottom corner */

    gdImageLine( im, x + font_x * ( max + 2 ), y,
		 x + font_x * ( max + 2 ), y + font_y * ( rows + 2 ), rcolor );

    /* rigt bottom corner -> left bottom corner */

    gdImageLine( im, x + font_x * ( max + 2 ), y + font_y * ( rows + 2 ),
		 x, y + font_y * ( rows + 2 ), rcolor );

    /* left bottom corner -> right top corner */

    gdImageLine( im, x, y + font_y * ( rows + 2 ), x, y, rcolor );

    /* fill the background of the note with 'color' */

    for( i = y + 1; i < y + font_y * ( rows + 2 ); i++ )
      gdImageLine( im, x + 1, i, x + font_x * ( max + 2 ) - 1, i, color );

    /* write in the text */

    for( i = 0; i < rows; i++ )
      gdImageString( im, FONT, x + font_x, y + font_y * ( i + 1 ), 
		     o.txt[i], tcolor );
  }
}

void main(){
  
  gdImagePtr it;
  int white, blue, dgray, black, yellow, n, i;
  FILE *fp;
  NOTE *list;

  if((fp = fopen( DB, "r" )) == NULL )
    n=0;
  else
    if(fscanf( fp,"%u",&n) != 1)
      n=0;
  list = ( NOTE * ) malloc( sizeof(NOTE) * n );
  fread( list, sizeof( NOTE ), n, fp );
  fclose( fp );
  
  it = gdImageCreate( X_BOARD_SIZE, Y_BOARD_SIZE );
  
  white = gdImageColorAllocate( it, 255, 255, 255 );
  dgray = gdImageColorAllocate( it, 64, 64, 64 );
  yellow = gdImageColorAllocate( it, 255, 255, 128 );
  blue = gdImageColorAllocate( it, 0, 0, 255 );
  black = gdImageColorAllocate( it, 0, 0, 0 );
  
  gdImageFill( it, 0, 0, dgray );
  
  for( i = 0; i < n; i++ )
    gdMakeNote( it, list[i], white, black, black );
  
  gdImageColorTransparent( it, dgray );
  
  fprintf( stdout, "Content-type: image/gif\n\n" );
  gdImageGif( it, stdout );
}

