#include <stdio.h>
#include <signal.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#include <syslog.h>
#include <errno.h>
#ifdef sun
#include <sys/fcntl.h>
#include <sys/termios.h>
#endif
#include <time.h>
#ifdef _AIX
#include <sys/time.h>
#endif

int flagrestartsocket();
int debug=0;
int do_alarm();
int do_check_timers=0;
static int startmain=0;
int remove_client_des();
char myhostname[512];
char masterhost[512];
int flushbuf();
int maxconn=0; /* 0 = unlimited */
extern int check_child_death;
static int alarm_flag=0;
static int loop_pass_cnt=0;
int set_alarm_flag();

extern int read_request(),initial_message(),child_death();

static int print_error(num,msg)
     int num;
     char *msg;
{
#ifndef some_system_that_I_dont_know_of
  extern int sys_nerr;
  extern char *sys_errlist[];
#endif
  if((num<=0) || (num>=sys_nerr)) syslog(LOG_ERR,"%s:%d",msg,num);
  else syslog(LOG_ERR,"%s: %s",msg,sys_errlist[num]);
}

struct timeval t={5,0};
static char *service;

main(argc,argv)
     int argc;
     char **argv;
{
  chdir("/");
  set_max_idletime(500/30); /* 2 minutes */
  signal(SIGPIPE,SIG_IGN);
  signal(SIGCLD,child_death);
  debug=0;
  if(argc>1) {
    if(strcmp(argv[1],"-maxconn")==0) {
      maxconn=atoi(argv[2]);
      debug=argc-3;
    }
    else debug=argc-1;
  }
  if(debug) {
    signal(SIGHUP,flushbuf);
    service="bop3";
  }
  else {
    service="pop3";
    if(fork()) exit(0);
    else {
      int d;

      close(0);
      close(1);
      close(2);
      d=open("/dev/tty",O_RDWR);
      ioctl(d,TIOCNOTTY,0);
      close(d);
      open("/",O_RDONLY);
      dup(0);
      dup(0);
    }
  }
#ifdef LOG_MAIL
  openlog("popd",LOG_PID,LOG_MAIL);
#else
  openlog("popd",LOG_PID);
#endif
  signal(SIGALRM,set_alarm_flag);
  gethostname(myhostname,512);
#ifdef USE_BP
  bgetmasterhost(masterhost);
#endif
  init_server(); /* Initialize server routines */
  restartsocket(); /* Create server socket */
  set_notify_closefun(flagrestartsocket);
  set_error_fun(print_error);
  request_check_timers(0,NULL); /* Starts up timer check */
  while(do_select(&t)>=0) {
    if(alarm_flag==0 && (loop_pass_cnt++>50)) {
      if(very_late_alarm()) {
	syslog(LOG_ERR,"Alarm isn't working!\n");
	loop_pass_cnt=0;
	signal(SIGALRM,set_alarm_flag);
	set_alarm_flag();
	if(sigblock(0)&sigmask(SIGALRM)) {
	  syslog(LOG_ERR,"SIGALRM is being masked!\n");
	  sigsetmask(sigblock(0)&(~sigmask(SIGALRM)));
	}
      }
      else loop_pass_cnt=0;
    }
    if(startmain) {
      /* Need to recreate the server socket */
      restartsocket();
      startmain=0;
    }
    if(alarm_flag>0) {
      alarm_flag=0;
      if(do_alarm()==0) loop_pass_cnt=0;
    }
    while(check_child_death>0) {
      check_child_death--;
      handle_child_death();
    }
    if(do_check_timers>0) {
      /*Need to check the timeout timer */
      check_timers();
      do_check_timers--;
    }
  }
}

restartsocket()
{
  init_unauth_global(service,read_request,remove_client_des,initial_message);
}

static flagrestartsocket(sock)
     int sock;
{
  if(sock>=0) close(sock);
  startmain=1;
}

flushbuf() {
  fflush(stdout);
  fflush(stderr);
  exit(0);
}

#ifndef USE_BP
char *sstrdup(s)
     char *s;
{
  char *r;
  int len=strlen(s);
  
  r=malloc(len+1);
  strcpy(r,s);
  return(r);
}

void sfree(s)
     char *s;
{
  free(s);
}
#endif

int set_alarm_flag() {
  alarm_flag++;
}
