#include <stdio.h>
#include "popd.h"
#include "userinfo.h"
#include "fdlist.h"

/* Take care of message management functions, deletion, listing, etc. */

delete_message(socket,fd,num)
     int socket;
     struct fdlist *fd;
     int num;
{
  if(num<=0 || num>fd->userdata->info.nummessages) {
    write_err(socket,"Message number %d is out of range.",num);
    return(1);
  }
  if(fd->userdata->info.messlist[num-1].flags&DELETED) {
    write_err(socket,"Message number %d has already been deleted.",num);
    return(1);
  }
  fd->userdata->info.messlist[num-1].flags|=DELETED;
  fd->userdata->info.numdeleted++;
  fd->userdata->info.deletedsize+=fd->userdata->info.messlist[num-1].length;
  write_ok(socket,"Message number %d has been deleted.",num);
  return(0);
}

undelete_messages(socket,fd,num)
     int socket;
     struct fdlist *fd;
     int num;
{
  if(num<0) {
    int x;

    for(x=0;x<fd->userdata->info.nummessages;x++) {
      fd->userdata->info.messlist[x].flags&=~DELETED;
    }
    fd->userdata->info.numdeleted=0;
    fd->userdata->info.deletedsize=0;
  }
  else {
    if((num==0) || (num>fd->userdata->info.nummessages)) {
      write_err(socket,"Message number %d is out of range.",num);
      return(1);
    }
    if(!(fd->userdata->info.messlist[num-1].flags&DELETED)) {
      write_err(socket,"Message number %d was not deleted.",num);
      return(1);
    }
    fd->userdata->info.messlist[num-1].flags&=~DELETED;
    fd->userdata->info.numdeleted--;
    fd->userdata->info.deletedsize-=fd->userdata->info.messlist[num-1].length;
  }
  write_ok(socket,"Maildrop has %d messages (%d octets).",fd->userdata->info.nummessages,fd->userdata->info.filesize);
  return(0);
}

pop_stat(socket,fd)
     int socket;
     struct fdlist *fd;
{
  write_ok(socket,"%d %d",fd->userdata->info.nummessages-fd->userdata->info.numdeleted,fd->userdata->info.filesize-fd->userdata->info.deletedsize);
  return(0);
}

pop_list(socket,fd,num)
     int socket;
     struct fdlist *fd;
     int num;
{
  char buf[512];

  if(num<0) {
    int x;

    write_ok(socket,"%d messages (%d octets)",fd->userdata->info.nummessages-fd->userdata->info.numdeleted,fd->userdata->info.filesize-fd->userdata->info.deletedsize);
    for(x=0;x<fd->userdata->info.nummessages;x++) {
      if(!(fd->userdata->info.messlist[x].flags&DELETED)) {
	sprintf(buf,"%d %d\r\n",x+1,fd->userdata->info.messlist[x].length);
	write_socket(socket,buf,strlen(buf));
      }
    }
    write_socket(socket,".\r\n",3);
  }
  else {
    if(num==0 || num>fd->userdata->info.nummessages) {
      write_err(socket,"Message number %d does not exist.",num);
      return(1);
    }
    if(fd->userdata->info.messlist[num-1].flags&DELETED) {
      write_err(socket,"Message %d has been deleted.",num);
      return(1);
    }
    write_ok(socket,"%d %d",num,fd->userdata->info.messlist[num-1].length);
  }
  return(0);
}
