#include <stdio.h>
#include <ctype.h>
#include "cmdlist.h"

static struct {
  char *name;
  char cmdtype;
  int args;
} cmdlist[]={
  "USER",KEY_USER,1,
  "PASS",KEY_PASS,1,
  "RPOP",KEY_RPOP,1,
  "QUIT",KEY_QUIT,0,
  "RETR",KEY_RETR,1,
  "DELE",KEY_DELE,1,
  "RSET",KEY_RSET,0,
  "LIST",KEY_LIST,-1,
  "STAT",KEY_STAT,0,
  "XTND",KEY_XTND,-10,
  "TOP",KEY_TOP,2,
  "NOOP",KEY_NOOP,0,
  "LAST",KEY_LAST,0,
  NULL,KEY_PASS,0,
};

parse_cmd(buf,list,max,keyword,socket)
     char *buf;
     char **list;
     int max;
     int *keyword;
     int socket;
{
  int len,argnum,x;

  while(*buf && isspace(*buf)) buf++;
  if(*buf==0) return(1);
  len=strlen(buf);
  while(len && isspace(buf[len-1])) len--;
  if(len==0) return(1);
  buf[len]=0;
  argnum=0;
  do {
    list[argnum++]=buf;
    list[argnum]=NULL;
    while(*buf && !isspace(*buf)) buf++;
    if(*buf) {
      *(buf++)=0;
      while(isspace(*buf) && *buf) buf++;
    }
  } while(*buf);
  for(x=0;cmdlist[x].name!=NULL;x++) {
    if(strcmpi(list[0],cmdlist[x].name)==0) break;
  }
  if(cmdlist[x].name==NULL) {
    write_err(socket,"Unknown command \"%s\".",list[0]);
    return(1);
  }
  if(((cmdlist[x].args<0) && ((1-cmdlist[x].args)<argnum)) || (cmdlist[x].args>=0 && cmdlist[x].args!=(argnum-1))) {
    write_err(socket,"Incorrect arguments to \"%s\" %d.",list[0],argnum);
    return(1);
  }
  *keyword=cmdlist[x].cmdtype;
  return(0);
}

strcmpi(a,b)
     char *a,*b;
{
  char c,d;

  do {
    c=(*a);
    d=(*b);
    if(c==d) {
      if(c==0) return(0);
    }
    else {
      if(islower(c)) c=(toupper(c));
      if(islower(d)) d=(toupper(d));
      if(c!=d) return(c-d);
    }
    a++;
    b++;
  } while(1);
  /* NOTREACHED */
}
