#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <syslog.h>
#include "popd.h"
#include "userinfo.h"
#include "fdlist.h"

#ifndef FSEEK_SET
#define FSEEK_SET 0
#endif

extern int debug;
int send_some_message();

send_message(socket,fd,messagenum,length)
     int socket;
     struct fdlist *fd;
     int messagenum;
     int length;
{
  int messagestart,messagelength,flags;
  FILE *f;
  struct fdlist *d;
  struct stat s,s2;

  if(messagenum<=0 || messagenum>fd->userdata->info.nummessages) {
    write_err(socket,"Message number out of range.");
    return(0);
  }
  messagenum--;
  messagestart=fd->userdata->info.messlist[messagenum].offset;
  messagelength=fd->userdata->info.messlist[messagenum].length;
  flags=fd->userdata->info.messlist[messagenum].flags;
  if(flags&DELETED) {
    write_err(socket,"Message %d has been deleted.",messagenum+1);
    return(0);
  }
  if(fd->userdata->info.messlist[messagenum].readflag==0) {
    if(debug) printf("Beenmodified set in read\n");
    fd->userdata->beenmodified=1;
  }
  fd->userdata->info.messlist[messagenum].flags|=RETRIEVED;
  if(!fileok(fd->userdata->dropfile,fd->userdata->info.filesize,&s)) f=NULL;
  else f=fopen(fd->userdata->dropfile,"r");
  if(f==NULL) {
    write_err(socket,"Unable to open maildrop.");
    return(0);
  }
  if(fstat(fileno(f),&s2) || (s2.st_ino!=s.st_ino) || (s2.st_dev!=s.st_dev)) {
    fclose(f);
    write_err(socket,"Unable to open maildrop.");
    return(0);
  }
  if(fd->userdata->lastmessage<(messagenum+1)) {
    fd->userdata->lastmessage=messagenum+1;
  }
  fseek(f,messagestart,FSEEK_SET);
  add_des(fileno(f),13,send_some_message,NULL,f);
  d=get_fdlist_entry(fileno(f));
  write_ok(socket,"%d octets",messagelength);
  if(debug) printf("Length is %d, messagelength is %d\n",length,messagelength);
  d->reqnum=length;
  d->blksz=messagelength;
  d->send_group_des=socket;
  d->state=0;
  set_watermark(socket,100000,10000,fileno(f));
  return(0);
}

static char buf[513];
send_some_message(socket,d,abrt)
     int socket;
     struct fdlist *d;
     int abrt;
{
  int len,linecount,stoplen,outlen;
  struct fdlist *outd;
  char *bptr;
  int nllastwritten=1;

  buf[0]='.';
  stoplen=d->reqnum;
  if(stoplen<0) stoplen=1000000;
  if(abrt) goto abort;
  if(d->blksz<=0) {
  done:
    clear_watermark(d->send_group_des);
    if(debug) printf("All done, blksz is %d\n",d->blksz);
    if(!nllastwritten) write_socket(d->send_group_des,"\r\n",2);
    write_socket(d->send_group_des,".\r\n",3);
    fclose(d->fd);
    return(1);
  abort:
    clear_watermark(d->send_group_des);
    if(debug) printf("aborting...\n");
    syslog(LOG_ERR,"abort: called in send_some_message()");
    if(d->fd!=NULL) {
      fclose(d->fd);
      d->fd=NULL;
    }
    return(1);
  }
  outd=get_fdlist_entry(d->send_group_des);
  if((outd==NULL) || (outd->userdata==NULL)) goto abort;
  linecount=100;
  if(d->state==0) {
    while((linecount>0) && (d->blksz>0) && (fgets(buf+1,512,d->fd)!=NULL)) {
      linecount--;
      len=strlen(buf+1);
      outlen=len;
      if(buf[1]=='.') {
	bptr=buf;
	outlen++;
      }
      else bptr=buf+1;
      if(bptr[outlen-1]=='\n') {
	bptr[outlen-1]='\r';
	bptr[outlen]='\n';
	outlen++;
      }
      d->blksz-=len;
      if(write_socket(d->send_group_des,bptr,outlen)<0) goto abort;
      if(len==1) {
	d->state=1;
	break;
      }
    }
    if(d->blksz<=0) {
      if(bptr[outlen-1]!='\n') nllastwritten=0;
      goto done;
    }
    if(linecount<=0) return(0);
  }
  while((linecount>0) && (stoplen>0) && (fgets(buf+1,512,d->fd)!=NULL)) {
    linecount--;
    stoplen--;
    len=strlen(buf+1);
    outlen=len;
    if(buf[1]=='.') {
      bptr=buf;
      outlen++;
    }
    else bptr=buf+1;
    if(bptr[outlen-1]=='\n') {
      bptr[outlen-1]='\r';
      bptr[outlen]='\n';
      outlen++;
    }
    d->blksz-=len;
    if(debug) printf("lines %d, blksz is %d\n",linecount,d->blksz);
    if(write_socket(d->send_group_des,bptr,outlen)<0) {
      if(debug) printf("Calling abort\n");
      goto abort;
    }
    if(d->blksz<=0) {
      if(bptr[outlen-1]!='\n') nllastwritten=0;
      goto done;
    }
  }
  if(stoplen<=0) goto done;
  d->reqnum=stoplen;
  return(0);
}

pause_send_message(d,fd)
     int d;
     struct fdlist *fd;
{
  lockdes(d);
}

restart_send_message(d,fd)
     int d;
     struct fdlist *fd;
{
  unlockdes(d);
}

