#include <stdio.h>
#include "mymalloc.h"

/* The Grim Reaper Variable(tm). Increments every 30 seconds. Conections
   that are idle for more than a specified period get nukied. */

static int idletimer=0;

/* This contains timers for each of the connections. */

static int *connlist=NULL,maxconn=0-1;
static int maxtimeout=4; /* Maximum time difference before closing */
extern int debug;
extern struct fdlist *get_fdlist_entry();

/* Add descriptor d to be timed. */
add_descriptor_timer(d)
     int d;
{
  int x;

  if(connlist==NULL) {
    connlist=tnmalloc(int,d+1);
    for(x=0;x<d;x++) connlist[x]=0-1;
    maxconn=d;
  }
  else if(d>maxconn) {
    tnrealloc(connlist,int,d+1);
    for(x=maxconn+1;x<d;x++) connlist[x]=0-1;
    maxconn=d;
  }
  connlist[d]=idletimer;
}

/* Set the maximum timeout to t. */
set_max_idletime(t)
     int t;
{
  maxtimeout=t;
}

/* Indicate that descriptor d is active */
touch_timer(d)
     int d;
{
  connlist[d]=idletimer;
}

/* Turn off the timer on descriptor d */

turn_off_idletimer(d)
     int d;
{
  connlist[d]=0-1;
}

/* Run a timer check, and close descriptors that have timed out */
check_timers() {
  int x;

  if(debug) fprintf(stderr,"Checking timer interval %d\n",idletimer);
  for(x=0;x<=maxconn;x++) {
    if((connlist[x]>=0) && (idletimer-connlist[x])>=maxtimeout) {
      turn_off_idletimer(x);
      abort_session(get_fdlist_entry(x));
      close_des(x);
    }
  }
  idletimer++;
}

/* This is called when the alarm goes off; it sets a flag, reschedules the
   timer, and returns. */

request_check_timers(junk,ptr)
     int junk;
     void *ptr;
{
  extern int do_check_timers;

  do_check_timers++;
  add_alarm(30,request_check_timers,0,NULL);
}
