#include <stdio.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <syslog.h>
#include <errno.h>
#ifdef sun
#include <sys/fcntl.h>
#endif
#include "popd.h"
#include "userinfo.h"
#include "fdlist.h"
#define BUFAMT 16384
/* #define USE_STDIO_FOR_READ */
static int write_some_messages();

/* Write out the undeleted messages to disk for descriptor fd, with updated
   status lines. Returns a non-zero value if it's unable to write it. Also,
   if there have been no changes, it doesn't actually rewrite the file. */

write_out_messages(socket,fd)
     int socket;
     struct fdlist *fd;
{
  int d,e;
  struct fdlist *f2;
  struct stat s,s2;
  int mode,uid,gid;
  FILE *rddes=NULL;
  char buf[512];

  turn_off_idletimer(socket);
  if(fd->userdata->dropfile==NULL || lstat(fd->userdata->dropfile,&s)) {
    do_exit(socket,fd);
    return(0);
  }
  if(!(s.st_mode&S_IFREG)) {
    do_exit(socket,fd);
    return(0);
  }
  if(!fd->userdata->beenmodified) {
    /* If it hasn't changed, don't bother writing out the file again */
    do_unlock_spool_file_and_exit(socket,fd);
  }
  else {
    /* USE_STDIO_FOR_READ means that it should use the stdio package to read
       the file in. */
#ifdef USE_STDIO_FOR_READ
    rddes=fopen(fd->userdata->dropfile,"r");
    if(rddes!=NULL) d=fileno(rddes);
    else d=0-1;
#else
    d=open(fd->userdata->dropfile,O_RDONLY|O_NDELAY);
#endif
    if(d<0) return(1);
    if(fstat(d,&s2) || (s2.st_ino!=s.st_ino) || (s2.st_dev!=s.st_dev)) {
      close(d);
      if(rddes!=NULL) fclose(rddes);
      return(1);
    }
    strcpy(buf,fd->userdata->dropfile);
    strcat(buf,".2");
    fstat(d,&s);
    if(unlink(buf) && errno!=ENOENT) return(1);
    e=open(buf,O_WRONLY|O_CREAT|O_NDELAY|O_EXCL,s.st_mode);
    if(e<0) {
      close(d);
      if(rddes!=NULL) fclose(rddes);
      return(1);
    }
    fchown(e,s.st_uid,s.st_gid);
    lockdes(socket);
    add_des(d,5,write_some_messages,NULL,rddes);
    f2=get_fdlist_entry(d);
    f2->send_allowed_des=e;
    f2->blksz=0;
    f2->state=0;
    f2->opened=0;
    f2->firsttime=0;
    f2->send_group_des=socket;
    f2->send_butmp_des=0;
    f2->userdata=tmalloc(struct userdata);
    f2->userdata->filewritebuf=tnmalloc(char,BUFAMT+16);
    f2->userdata->filewriteamt=0;
  }
  return(0);
}

static int write_some_messages(des,fdes,abrt)
     int des;
     struct fdlist *fdes;
     int abrt;
{
  struct fdlist *d2;
  int len,x,nummessages,messnum;
  extern int debug;
  int amt,fpos,readamt;
  int totamt=BUFAMT;
  char *bptr,*buf;
  struct userdata *userdata;

  if(abrt) {
  abort:
#ifdef USE_STDIO_FOR_READ
    if(fdes->fd!=NULL) {
      fclose(fdes->fd);
      fdes->fd=NULL;
    }
#endif
    if(d2!=NULL && d2->userdata!=NULL && d2->userdata->dropfile!=NULL) {
      strcpy(buf,d2->userdata->dropfile);
      strcat(buf,".2");
      unlink(buf);
    }
    close(fdes->send_allowed_des);
    unlockdes(fdes->send_group_des);
    if(fdes->userdata!=NULL) {
      if(fdes->userdata->filewritebuf!=NULL) {
	free(fdes->userdata->filewritebuf);
	fdes->userdata->filewritebuf=NULL;
      }
      free(fdes->userdata);
      fdes->userdata=NULL;
    }
    return(1);
  }
  if(fdes->userdata->filewriteamt==0) {
    bptr=fdes->userdata->filewritebuf;
    buf=bptr;
    fdes->firsttime++;
    d2=get_fdlist_entry(fdes->send_group_des);
    userdata=d2->userdata;
    nummessages=userdata->info.nummessages;
    messnum=fdes->send_butmp_des-1;
    switch(fdes->state) {
    case 0:
    state0:
      fdes->state=0; /* Make sure we end up back here */
      fdes->blksz=0;
      fdes->reqnum=0;
      for(x=fdes->send_butmp_des;x<nummessages && userdata->info.messlist[x].flags&DELETED;x++);
    again:
      if(x>=nummessages) {
	if(bptr==buf) {
	  /* Nothing needs written, so we're done. */
#ifdef USE_STDIO_FOR_READ
	  fclose(fdes->fd);
	  fdes->fd=NULL;
#endif
	  close(fdes->send_allowed_des);
	  free(fdes->userdata->filewritebuf);
	  free(fdes->userdata);
	  fdes->userdata=NULL;
	  close(des);
	  strcpy(buf,userdata->dropfile);
	  strcat(buf,".2");
	  unlink(userdata->dropfile);
	  rename(buf,userdata->dropfile);
	  unlockdes(fdes->send_group_des);
	  do_unlock_spool_file_and_exit(fdes->send_group_des,d2);
	  if(debug) printf("%d was passcount\n",fdes->firsttime);
	  return(1);
	}
	else {
	  /* There's stuff pending write, let's go try to write it. */
	  fdes->send_butmp_des=nummessages;
	  break;
	}
      }
      else {
	fpos=userdata->info.messlist[x].offset;
	if(fdes->reqnum==0) {
	  if(debug) printf("Doing seek to %d\n",fpos);
#ifdef USE_STDIO_FOR_READ
	  fseek(fdes->fd,fpos,SEEK_SET);
#else
	  lseek(des,fpos,SEEK_SET);
#endif
	}
	fdes->state=1;
	fdes->send_butmp_des=x+1;
	fdes->blksz += userdata->info.messlist[x].length;
	messnum=x;
	if((userdata->info.messlist[x].statuspos<0)) { /* No status line */
	  fdes->reqnum += userdata->info.messlist[x].headerend-fpos;
	  fdes->send_alias_des=4;
	}
	else if(userdata->info.messlist[x].flags&RETRIEVED && (!userdata->info.messlist[x].readflag)) {
	  /* It's been read & there is already a Status: line; replace it */
	  fdes->reqnum += userdata->info.messlist[x].statuspos-fpos;
	  fdes->send_alias_des=3;
	}
	else {
	  fdes->reqnum=fdes->blksz;
	  x=fdes->send_butmp_des;
	  if(x<nummessages && !(userdata->info.messlist[x].flags&DELETED)) goto again;
	  fdes->send_alias_des=1;
	}
	/* FALLTHROUGH */
      }
    case 1:
    state1:
      if(totamt==0) break;
      /* Copy fdes->blksz amount of data in BUFAMT-byte chunks */
      amt=fdes->reqnum;
      if(amt>totamt) amt=totamt;
#ifdef USE_STDIO_FOR_READ
      readamt=fread(bptr,1,amt,fdes->fd);
#else
      readamt=read(des,bptr,amt);
      if(readamt!=amt) {
	if(debug) printf("Only got %d amt reading\n",readamt);
	if(readamt<0) {
	  if(errno==EWOULDBLOCK) return(0);
	  syslog(LOG_ERR,"Error in read #3:%m\n");
	  goto abort;
	}
	amt=readamt;
      }
#endif
      bptr+=amt;
      totamt-=amt;
      fdes->blksz-=amt;
      fdes->reqnum-=amt;
      if(fdes->blksz==0) {
	fdes->state=0;
	goto state0;
      }
      if(fdes->reqnum==0) {
	switch(fdes->send_alias_des) {
	case 3:
	  amt=userdata->info.messlist[messnum].statuslen;
	  /* Now skip the Status: line in the input */
#ifdef USE_STDIO_FOR_READ
	  fseek(fdes->fd,amt,SEEK_CUR);
#else
	  lseek(des,amt,SEEK_CUR);
#endif
	  fdes->blksz-=amt;
	  strcpy(bptr,"Status: RO\n");
	  bptr+=11;
	  totamt-=11;
	  break;
	case 4:
	  if(userdata->info.messlist[messnum].flags&RETRIEVED) {
	    strcpy(bptr,"Status: RO\n");
	    bptr+=11;
	    totamt-=11;
	  }
	  else {
	    strcpy(bptr,"Status: U\n");
	    bptr+=10;
	    totamt-=10;
	  }
	  break;
	}
	if(totamt<0) totamt=0;
	fdes->reqnum=fdes->blksz;
	goto state1;
      }
      break;
    }
    fdes->userdata->filewriteamt=bptr-buf;
    fdes->userdata->filewriteptr=buf;
  }
  if(fdes->userdata->filewriteamt>0) {
    amt=write(fdes->send_allowed_des,fdes->userdata->filewriteptr,fdes->userdata->filewriteamt);
    if(amt<0 && errno==EWOULDBLOCK) amt=0;
    if(amt<0) {
      syslog(LOG_ERR,"Writing to spool .drop2 file:%m");
      goto abort;
    }
    if(debug && amt!=fdes->userdata->filewriteamt) printf("Write amt is %d\n",amt);
    fdes->userdata->filewriteamt-=amt;
    fdes->userdata->filewriteptr+=amt;
  }
  return(0);
}

int try_unlock_spool_file();

/* Retry unlocking until it succeeds, then close down the descriptor
   with a parting message. This is how we exit cleanly. */

do_unlock_spool_file_and_exit(socket,d2)
     int socket;
     struct fdlist *d2;
{
  if(unlock_spool_file(d2)==0) {
    do_exit(socket,d2);
    return(0);
  }
  else {
    lockdes(socket);
    add_alarm(5,try_unlock_spool_file,socket,d2);
    return(1);
  }
}

/* It keeps trying to unlock every 5 seconds until it succeeds. */

try_unlock_spool_file(socket,fdes)
     int socket;
     struct fdlist *fdes;
{
  if(unlock_spool_file(fdes)==0) {
    unlockdes(socket);
    do_exit(socket,fdes);
    return(0);
  }
  else {
    add_alarm(5,try_unlock_spool_file,socket,fdes);
    return(1);
  }
}

/* Final routine called to print exit message to the client, then close
   the socket up.*/

do_exit(socket,d2)
     int socket;
     struct fdlist *d2;
{
  write_ok(socket,"Popmail server signing off. Byebye, and buy bonds.");
  if(d2->userdata->writebuf!=NULL) d2->userdata->closeflag=1;
  else close_des(socket);
}
