#! /local/bin/perl -w
#
# $Id: bozocgi.pl,v 2.2 1995/10/18 12:18:48 mrg Exp $
#
# do the cgi-bin stuff.
#
# bozoleft(p) 1995 the bozotic softwar foundation
#
# author: mrg@mame.mu.oz.au

require 5;

sub do_cgi_bin
{
	if ($url =~ m#^/cgi-bin/#)
	{
		unless ($cgidir)
		{
			error(501, $url, "cgi-bin has not been configured");
		}
		$ENV{'SERVER_NAME'} =		$server_name if $server_name;
		$ENV{'CONTENT_TYPE'} =		$content_type if $content_type;
		$ENV{'CONTENT_LENGTH'} =	$content_length if $content_length;
		$ENV{'GATEWAY_INTERFACE'} =	"CGI/1.1";
		$ENV{'SERVER_PORT'} =		80 || $tcp_port;
		$ENV{'SERVER_PROTOCOL'} =	$proto;
		$ENV{'REQUEST_METHOD'} =	$method;
		$ENV{'REMOTE_ADDR'} =		$inetaddr;

		# generate command line
		$command = $url;
		$command =~ s#^/cgi-bin##;
		$command =~ s/\?.*$//;
		if ($command =~ m#^(/.+?)(/.*)$#)
		{
			$command = $1;
			$path_info = $2;
		}
		$command = "$cgidir$command";

		$query_string = $url;
		$query_string =~ s/^[^\?]*\??//;
		$query_string = "" if (length($query_string) > 250); # safe side
		return error(404, $url, "$command -x failed: $!") unless -x $command;
		logit("executing: $url ($command $query_string)");

		$ENV{'PATH_INFO'} = $path_info if $path_info;
		$ENV{'PATH_TRANSLATED'} = "$htmldir/$path_info" if $path_info;

		($ENV{'SCRIPT_NAME'} = $command) =~ s#./*##;
		$ENV{'QUERY_STRING'} = $query_string;

		# Parsing of sent-back headers is not implemented. 

		$date = localtime;
		print <<TheEnd;
HTTP/1.0 200 Document follows
Date: $date
Server: $ENV{SERVER_SOFTWARE}
TheEnd

		open(CGI, "|$command $query_string") || return error(500, $url, "pipe: $!");
		select(CGI);
		$| = 1;
		while (<CGI>)
		{
			s#[\n\r]##;
			print "$_\n";
		}
		close CGI;
		exit 0;
	}
}
