#! /local/bin/perl -w
#
# @(#) $Id: bozobind.pl,v 2.12 1996/05/20 18:26:48 mrg Exp $
#
# bind to $tcpport, and fork off stuff.
#
# bozoleft(p) 1995, 1996 the bozotic softwar foundation
#
# author: mrg@eterna.com.au

require 5;

use Socket qw(AF_INET PF_INET SOCK_STREAM);

sub daemon
{
	death("this needs to run as root!") if $tcpport < 1024 && $>;
	death("no \$uid defined.") if $tcpport < 1024 && !$uid;
	$pid = fork;
	death("can't fork: $!") unless defined $pid;
	$pid && exit;		# background

	# set up a server socket
	$this = pack($sockaddr, AF_INET, $tcpport, "\0\0\0\0");
	socket(S, PF_INET, SOCK_STREAM, 6) || death("socket: $!");
	bind(S, $this) || death("bind: $!");
	listen(S, 5) || death("listen: $!");
	select((select(S), $| = 1)[0]);
	if (defined $uid) {
		$uid = getpwnam($uid) unless $uid =~ /^\d+$/;
		($<, $>) = ($uid, $uid);	# does a setuid(2) call.
	}
# XXX should be able to remove groups here but perl won't allow it!  argh.

	$SIG{'TERM'} = 'sig_term';
	$SIG{'CHLD'} = 'sig_chld';

	logit("bozohttpd $version starting in daemon mode ($<, $>; $(, $))");
	for (;;) {
		unless (accept(NS,S)) {
			logit("accept failed: $!");
			next;
		}
		$pid = fork;
		death("can't fork: $!") unless defined $pid;
		if ($pid) {		# real server
			close NS;
			next;
		}
		# server process
		open(STDIN, "+<&NS") || death("dup2 ns->stdin: $!");
		open(STDOUT, "+>&NS") || death("dup2 ns->stdout: $!");
		close NS;

		$log_connection = 1;
		do_connection();
		exit;
	}
}

sub sig_term
{
	death("exiting on SIGTERM...");
}

sub sig_chld
{
	wait;
}

sub bozobind'killwarnings
{
	$log_connection = $version = $sockaddr;
}
