;; silly-mail.el -- Insert silly mail headers in your outgoing messages
;;
;; Mostly written by Noah Friedman <friedman@prep.ai.mit.edu>
;; Not ready for release.

;; $Id: silly-mail.el,v 1.6 1994/08/09 20:53:04 friedman Exp $

;; I can't claim a copyright/left on any of this.  It's too silly, and
;; besides I borrowed ideas and functions from many people and places.
;; Just use and distribute this stuff in the spirit of the GPL (the
;; add-hook function came from the version 19 subr.el, so I guess it's
;; already copylefted)
;;
;; This file is not part of anything except my own warped collection.
;; It is distributed in the hope that it will be silly, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;; or FITNESS FOR A PARTICULAR PURPOSE, or humor for that matter.
;;
;; To use this program, put it somewhere in your load path, optionally
;; byte-compile it, and {auto,}load it.  Your mail-setup-hook should be set
;; to run one of mail-add-all-silly-headers,
;; mail-add-various-silly-headers, or mail-add-random-silly-header.
;;

(require 'friedman-mail-utils)
(provide 'silly-mail)


;; Variable declarations

(defvar suppress-drdoom-fodder nil 
  "value `t' means to avoid adding Dr. Doom's favorite key words to
your outgoing mail headers.")

(defvar suppress-flames nil
   "value `t' means don't add a random flaming remark to your outgoing
mail headers, you pathetic stupid cretin.")

;; Suppressed by default because not everyone has the `kibologize.el' package.
(defvar suppress-kibology t
   "value `t' means don't add words of wisdom from Kibo to your mail headers.")

(defvar suppress-nsa-fodder nil
  "value `t' means don't insert subversive key words in your mail
headers that the NSA undoubtedly greps for")

;; Suppressed by default because not everyone has the `shop' program.
(defvar suppress-shopping-list t
  "value `t' means to avoid adding weird shopping lists to your
outgoing mail headers.")

(defvar suppress-swifties nil 
  "value `t' means not to insert Tom Swifties in your outgoing mail headers.")

(defvar suppress-x-taunts nil
   "value `t' means not to insert flames about X windows in your
outgoing mail headers.")

(defvar suppress-zippy-quotes nil "Yow!  Am I being suppressed yet?")

(defvar suppress-antipastobozoticataclysm nil
  "value `t' means not to insert antipastobozoticataclysms in your
outgoing mail headers")

;; Taunts for mail-add-x-taunt.  Thanks to jwz@lucid.com for
;; contributing this.
(defconst x-taunt-strings
    '["Dissatisfaction guaranteed." "Don't get frustrated without it."
      "Even your dog won't like it." "Flakey and built to stay that way."
      "Flawed beyond belief." "Form follows malfunction."
      "Complex nonsolutions to simple nonproblems." "It could happen to you."
      "Garbage at your fingertips." "The Cutting Edge of Obsolescence."
      "Live the nightmare." "It could be worse, but it'll take time." 
      "Japan's secret weapon." "Let it get in YOUR way."
      "The art of incompetence." "More than enough rope."
      "No hardware is safe." "Power tools for power fools."
      "Power tools for power losers." "Putting new limits on productivity."
      "The defacto substandard." "The first fully modular software disaster."
      "The joke that kills." "The problem for your problem."
      "A terminal disease." "There's got to be a better way."
      "A moment of convenience, a lifetime of regret."
      "A moment of regret, a lifetime of inconvenience."
      "Sometimes you fill a vacuum and it still sucks."
      "graphics hacking :: roman numerals : sqrt(pi)"
      "It was hard to write; it should be hard to use."
      "All the problems and twice the bugs."
      "Warn your friends about it." "You'll envy the dead."
      "Naah."
      "You'd better sit down."
      ])

;; Tom Swifties.  Blame to Noah Friedman and Michael Bushnell.
(defconst tom-swifties-strings
  '[
    "\"I can't stand baby food,\" Tom said in a strained voice."
    "\"We're all out of flowers,\" Tom said lackadaisically."
    "\"I don't have the slightest idea how to milk this cow,\" Tom said in utter confusion."
    "\"Ed is the Standard Text Editor,\" Tom sed."
    "\"It needs more seasoning,\" Tom said sagely."
    "\"Don't forget to shut down the computer,\" Tom said haltingly."
    "\"I don't have any piano music,\"  Tom said listlessly."
    "\"Finish titrating that solution,\" Tom said in a balanced tone."
    "\"I am writing lots of little verses,\"  Tom said blankly."
    "\"I've just been drafted,\"  Tom said impressively."
    "\"I feel like I'm running around in circles,\"  Tom said squarely."
    "\"And what should you set your PS1 shell variable to?\" Tom prompted."
    "\"I like to draw pictures with lots of detail,\" Tom said graphically."
    "\"The printer is using too much toner,\"  Tom said darkly."
    "\"I can chown files,\" Tom said in a privileged tone."
    "\"Read the appendix,\" Tom finally said."
    "\"It's really windy outside,\" said Tom with gusto."
    "\"I just don't understand the number seventeen,\" Tom said randomly."
    "\"I like Gregorian chants,\" Tom intoned."
    "\"My feet hurt,\" Tom said pedantically."
    "\"I'm gainfully employed at the Weight-Watchers gymnasium,\" Tom said wastefully."
    "\"My terminal is completely screwed up,\" Tom cursed."
    "\"The Hurd is running,\" Tom said collectively."
    "\"You light up my life,\" Tom said brightly."
    "\"I'm all out of soda-pop,\" Tom said effervescently."
    "\"Are we going to have a test today?\" Tom said quizzically."
    "\"I can't think of a good AI technique,\" Tom said searchingly."
    "\"I'm having deja-vu,\" Tom said again."
    "\"These are very nice apples,\" Tom said tartly."
    "\"All the cherry trees are dead,\" Tom said fruitlessly."
    "\"Turn that fan off,\" Tom said coldly."
    "\"Remember to kill all the child processes,\" Tom said on signal."
    "\"VI is much better than EMACS,\" Tom said with joy."
    "\"The GNU project will probably not be Posix conformant,\" Tom said noncommittally."
    "\"I really like penguins,\" Tom said in a flighty voice."
    "\"I recommend listening to radio station ``WHAT'',\" Tom said quietly."
    "\"He came at me out of the blue,\" Tom said airily."
    "\"My mouse buttons don't work,\" Tom said in a depressed voice."
    "\"I hate Frere Jacques,\" Tom said as he roundly denounced it."
    "\"I only like black and white,\" Tom said monotonously."
    "\"I've got a bucket full of forearms,\" Tom said wistfully."
    "\"You've put too much peanut butter on the sandwich,\" Tom said thickly."
    "\"Forty-two,\" Tom answered ultimately."
    "\"I'm really bored,\" Tom said flatly."
    "\"The sky is falling,\" Tom said in a crushed voiced."
    "\"The rooster was decapitated,\" Tom said in a crestfallen voice."
    "\"I'm hardly ever aware of what I'm going to do next,\" Tom said unconsciously."
    "\"I never get good bridge hands,\" Tom said in passing."
    "\"I got to get a text-processor that does my files the right way,\" Tom said awkwardly."
    "\"We'll have to take the stairs,\" Tom said in an elevated voice."
    "\"I can't get this knife to cut,\" Tom said dully."
    "\"I can't wait to see the doctor,\" Tom said impatiently."
    "\"I'm getting fat,\" Tom said expansively."
    "\"I like sun cartridge tapes,\" Tom said quickly."
    "\"I hate plastic,\" Tom said in an artificial voice."
    "\"I'll have to grade your test again,\" Tom remarked."
    "\"Time to test this new formula,\" Tom said experimentally."
    "\"I'm sorry to hear I knocked you up,\" Tom said after a pregnant pause."
    "\"I just burned my hand in the blast furnace,\" Tom said, overwrought."
    "\"My lenses will stay perfectly clear,\" Tom said optimistically."
    "\"I can't stop this uncontrollable sweating,\"  Tom said secretively."
    "\"Of course I know how to read,\" Tom said literally."
    "\"Joe said to get on IRC,\" Tom relayed."
    "\"I'm completely bankrupt,\" Tom said senselessly."
    "\"I like amputations,\" Tom said disarmingly."
    "\"I train dolphins,\" Tom said purposefully."
    "\"I'm sorry I broke your window,\" Tom said painfully."
    "\"I think it's time we got married,\" Tom said engagingly."
    "\"The sequence `M-4' is equivalent to `C-u 4',\" Tom said metaphorically."
    "\"I can't drink alcohol,\" Tom said spiritually."
    "\"Well, we're all here,\" Tom said presently."
    "\"RTFM,\" Tom informed."
    "\"I just sharpened my pencil,\" Tom said pointedly."
    "\"I have to finish sorting these writing utensils,\" Tom said pensively."
    "\"Superman is my hero,\" Tom said comically."
    "\"My tape drive is broken,\" Tom really said."
    "\"Any fresh fruit in the kitchen?\" Tom asked peeringly."
    "\"Use the `&' operator to get the address,\" Tom pointed out."
    "\"I just got some chicken wire,\" Tom said defensively."
    "\"I'm four feet three inches tall,\" Tom said shortly."
    "\"Checkmate,\" Tom said in a bored tone."
    "\"Socialism is dead,\" Tom communicated."
    "\"You pinhead,\" Tom said pointedly."
    "\"My hearing isn't very good,\" Tom said inaudibly."
    "\"The judge sentenced him to the chair,\" Tom said dielectrically."
    "\"I don't understand how square roots work,\" Tom said irrationally."
    "\"You have new mail,\" Tom said in his usual delivery."
    "\"It's patently obvious,\" Tom said licentiously."
    "\"I'm going to anesthetize these fruit flies,\" Tom said ethereally."
    "\"I hope this emulsion works,\" Tom said in suspense."
    "\"Eat me,\" was Tom's biting response."
    "\"I guess I shouldn't have broken the mirror,\" Tom reflected."
    "\"What is today's date?\" Tom asked in a timely fashion."
    "\"Condensed chicken soup,\" was Tom's canned response."
    "\"I don't want any champagne!\" Tom said, blowing his top."
    "\"This is illegal, I just know it,\" Tom said with conviction."
    "\"C++ is the wave of the future,\" Tom said objectively."
    "\"We're going to use decimal notation,\" Tom said tentatively."
    "\"I'm going to copy this tape,\" Tom said for the record."
    "\"Who drank the last beer?\" Tom asked, hopping mad."
    "\"It's really cold out here,\" Tom said in a muffled voice."
    "\"Care for some `suan la chow show'?\" Tom asked wantonly."
    "\"Be sure to add that host to the DNS,\" Tom said authoritatively."
    "\"Lisp is such a symbol-minded language,\" Tom commonly said."
    "\"Well, I guess we should pitch camp,\" Tom said tentatively."
    "\"I'm fond of Pavarotti,\" Tom said menacingly."
    "\"I had to remove a bullet from his gluteus maximus,\" Tom asphyxiated."
    "\"On the other hand, eating at a table is more civilized,\" Tom countered."
    "\"Well, it didn't increase at all,\" Tom said, nonplussed."
    "\"The sun just rose over the cemetary,\" Tom said in mourning."
    "\"I've finished counting the horses,\" Tom said summarily."
    "\"IBM is up 3 points,\" Tom said, taking stock of the situation."
    "\"If only we could piece together this crime,\" Tom said in a puzzled voice."
    "\"My brother Einstein was crazy,\" Tom said in a relative way."
    "\"What's the command syntax in `ed'?\" Tom questioned."
    "\"This anesthetic isn't very effective,\" Tom said unnervingly."
    "\"This awl is broken,\" Tom said pointlessly."
    "\"I don't WANNA get drunk,\" Tom wined."
    "\"I've amassed too many puns!\" Tom said critically."
    "\"My stained-glass windows are leaking,\" Tom said leadenly."
    "\"I can't get this fire started,\" Tom said woodenly."
    "\"We're going to sue you for that window system,\" Tom said inexorably."
    "\"How do I decode the inscriptions on this coffin?\" Tom said cryptically."
    "\"Quick!  Change the baby's diaper,\" Tom said rashly."
  ])

;; Antipastobozoticataclysms
(defconst antipastobozoticataclysm-strings
  ["When George Bush projectile vomits the antipasto on the Japanese."
   "Bariumenemanilow"
   ])

;; Primitives

;; ----------
;; From version 19 subr.el
(or (fboundp 'add-hook)
    (defun add-hook (hook function)
      "Add to the value of HOOK the function FUNCTION unless already present.
HOOK should be a symbol, and FUNCTION may be any valid function.
HOOK's value should be a list of functions, not a single function.
If HOOK is void, it is first set to nil."
      (or (boundp hook) (set hook nil))
      (or (if (consp function)
              ;; Clever way to tell whether a given lambda-expression
              ;; is equal to anything in the hook.
              (let ((tail (assoc (cdr function) (symbol-value hook))))
                (equal function tail))
            (memq function (symbol-value hook)))
          (set hook (cons function (symbol-value hook))))))


;; Silliness

;; ----------
(defun mail-add-all-silly-headers ()
  "Insert all available silly mail headers in current mail buffer, even if
they are being suppressed."
  (interactive)
  (mail-add-drdoom-fodder)
  (mail-add-flame)
  ;(mail-add-kibology)           ; remove this if you lack kibologize.el
  (mail-add-nsa-fodder)
  (mail-add-shopping-list)      ; remove this if you lack the `shop' program
  (mail-add-x-taunt)
  (mail-add-tom-swifty)
  (mail-add-zippy-quote)
  (mail-add-antipastobozoticataclysm))

;; ----------
(defun mail-add-random-silly-header ()
  "Insert a random mail header selected among those that are not being suppressed"
  (interactive)
  (let ((success nil)
        index
        (silly-mail-header-function-table
	 [mail-add-drdoom-fodder
	  mail-add-flame
	  mail-add-kibology
	  mail-add-nsa-fodder 
	  mail-add-shopping-list
	  mail-add-x-taunt
	  mail-add-tom-swifty
	  mail-add-zippy-quote
	  mail-add-antipastobozoticataclysm])
        (suppress-flags [ suppress-drdoom-fodder
                          suppress-flames
                          suppress-kibology
                          suppress-nsa-fodder
                          suppress-shopping-list
                          suppress-x-taunts
                          suppress-swifties
                          suppress-zippy-quotes
			  suppress-antipastobozoticataclysm
			  ]))
    (while (not success)
      (setq index (% (random) (length suppress-flags)))
      (if (< index 0)
	  (setq index (- index)))
      (setq success
            (not (eval (aref suppress-flags index)))))
    (funcall (aref silly-mail-header-function-table index))))

;; ----------
(defun mail-add-various-silly-headers ()
  "Add any and all headers that are not being suppressed"
  (interactive)
  (mapcar
   (function
    ;; Eval first arg as a variable, and if bound and not
    ;; nil, then run second arg as a function.
    (lambda (arglist)
      (let ((do-me-p (car arglist))
            (mail-function (cdr arglist)))
        (and (or (not (boundp do-me-p)) 
                 (not (symbol-value do-me-p)))
             (funcall (symbol-function mail-function))))))
   '((suppress-drdoom-fodder . mail-add-drdoom-fodder)
     (suppress-flames        . mail-add-flame)
     (suppress-kibology      . mail-add-kibology)
     (suppress-nsa-fodder    . mail-add-nsa-fodder)
     (suppress-shopping-list . mail-add-shopping-list)
     (suppress-x-taunts      . mail-add-x-taunt)
     (suppress-swifties      . mail-add-tom-swifty)
     (suppress-zippy-quotes  . mail-add-zippy-quote)
     (suppress-antipastobozoticataclysm . mail-add-antipastobozoticataclysm)
     )))

;; ----------
(defun mail-frob-tmp-addition-buffer (&optional header-length &optional columns)
  "Frobs current buffer (usually a tmp buffer used by various
functions to create silly mail headers).  This is lousy documentation,
but that's ok, because you're not supposed to use it directly anyway.
Read the source."
  (let (fill-column)
    (or header-length (setq header-length 10))
    (or columns (setq columns 3))
    (setq fill-column (- 78 columns))
    ;; If first line + header is longer than 79 chars, format things
    ;; appropriately (header-length doesn't include ': ' separater)
    (if (> (+ header-length (buffer-size)) 77)
        (progn
          (fill-region-as-paragraph (point-min) (point-max))
          (goto-char (point-max))
          (delete-char -1)
          (goto-char (point-min))
          (insert "\C-j")))
    ;; Insert a newline and indent first line if buffer is longer than
    ;; one line.
    (and (> (count-lines (point-min) (point-max)) 1)
         (indent-rigidly (point-min) (point-max) columns))))
 
(setq bizarre-gratuitous-variable '(unnecessary gratuitous list))

;; ----------
;; This is sort of based on the same principle as Steve Humble's NSA
;; fodder header.   Presumably, there is this cracker on the internet
;; (it was actually several people) who breaks in and reads your email,
;; looking for security-related information. 
(defun mail-add-drdoom-fodder ()
  "Annoy the MOD."
  (interactive)
  (let ((orig-buffer-modified-status (buffer-modified-p)))
    (mail-put-unique-header "X-Drdoom-Fodder" 
                     "CERT crash crypt drdoom passwd security root"
                     'force-replace)
    (set-buffer-modified-p orig-buffer-modified-status)))

;; ----------
;; Based on idea from jwz@lucid.com
(defun mail-add-flame ()
  "Add an insulting flame into your mail headers."
  (interactive)
  (or (fboundp 'flame) (load "flame" t t))
  (let (flame-buffer
        flame-quote
        (flame-header "X-Flame")
        (orig-buffer-modified-status (buffer-modified-p)))
    (save-excursion
      (setq flame-buffer (generate-new-buffer "*Flame*"))
      (set-buffer flame-buffer)
      (setq fill-column 70)

      (goto-char (point-min))
      (insert (concat 
               (sentence-ify 
                (string-ify (append-suffixes-hack (flatten (*flame)))))))

      (mail-frob-tmp-addition-buffer (length flame-header))

      (setq flame-quote (buffer-substring (point-min) (buffer-size)))
      (kill-buffer flame-buffer))

    (mail-put-unique-header flame-header flame-quote 'force-replace)
    (set-buffer-modified-p orig-buffer-modified-status)))

;; ----------
(defun mail-add-kibology ()
  "Add words of wisdom from the most holy grepmeister."
  (interactive)
  (or (fboundp 'kibologize) (load "kibologize" t t))
  (let (kibo-buffer
        kibo-quote
        (kibo-header "X-Kibo-Says")
        (orig-buffer-modified-status (buffer-modified-p)))
    (save-excursion
      (setq kibo-buffer (generate-new-buffer "*Kibo*"))
      (set-buffer kibo-buffer)
      (setq fill-column 70)

      (goto-char (point-min))
      (insert (concat 
               (sentence-ify 
                (string-ify (append-suffixes-hack (flatten (*kibologize)))))))

      (mail-frob-tmp-addition-buffer (length kibo-header))

      (setq kibo-quote (buffer-substring (point-min) (buffer-size)))
      (kill-buffer kibo-buffer))

    (mail-put-unique-header kibo-header kibo-quote 'force-replace)
    (set-buffer-modified-p orig-buffer-modified-status)))

;; ----------
;; Steve Humble was the first to have an NSA fodder header frob.
(defun mail-add-nsa-fodder ()
  "Add subversive key words to your mail headers.
This function does not actually exist." 
  (interactive)
  (or (fboundp 'snarf-spooks) (load "spook" t t))
  (let* ((spook-strings (shuffle-vector (snarf-spooks)))
         (nsa-header "X-NSA-Fodder")
         (nsa-header-length (length nsa-header))
         (spook-words nil)
         (i 0)
         (orig-buffer-modified-status (buffer-modified-p)))
    (while (< (+ (length (aref spook-strings i)) (length spook-words)) 
              (- fill-column nsa-header-length))
      (progn
        (setq spook-words (concat spook-words (aref spook-strings i) " "))
        (setq i (1+ i))))
    (mail-put-unique-header nsa-header spook-words 'force-replace)
    (set-buffer-modified-p orig-buffer-modified-status)))

;; ----------
;; Don't ask.
(defun mail-add-shopping-list (&optional item-number)
  "Add a shopping list into the *mail* buffer.  Probably called by
mail-setup-hook.  Optional argument ITEM-NUMBER is the number of
shopping items to go in the list.
   Note that you must have the \"shop\" program, written by some sicko
genius at Oberlin, for this to be of any use."
  (interactive "P")
  (let (shop-buffer 
        shop-list
        shop-quote
        (indent-column 3)
        (shop-list-size (int-to-string 
                         (or (and (listp 'item-number) 
                                  (car item-number))
                             item-number
                             3)))
        (shop-header "X-Shopping-List")
        (orig-buffer-modified-status (buffer-modified-p)))
    (save-excursion
      (setq shop-buffer (generate-new-buffer "*shop*"))
      (set-buffer shop-buffer)
      (call-process "shop" nil t nil shop-list-size)

      (goto-char (point-min))
      (delete-region (point) (progn (forward-line 1) (point)))
      (indent-rigidly (point-min) (point-max) indent-column)

      (setq shop-quote (buffer-substring (point-min) (buffer-size)))
      (kill-buffer shop-buffer))
    (mail-put-unique-header shop-header shop-quote 'force-replace)
    (set-buffer-modified-p orig-buffer-modified-status)))

;; ----------
(defun mail-add-tom-swifty ()
  (interactive)
  (let ((orig-buffer-modified-status (buffer-modified-p))
        (swift-buffer (generate-new-buffer "*Tom Swifties*"))
        (swift-header "X-Tom-Swifty")
        swifty)
    (save-excursion
      (set-buffer swift-buffer)
      (insert (aref tom-swifties-strings (% (logand (random) 65535)
                                            (length tom-swifties-strings))))
      (mail-frob-tmp-addition-buffer (length swift-header))
      (setq swifty (buffer-substring (point-min) (point-max)))
      (kill-buffer swift-buffer))
      (mail-put-unique-header swift-header swifty 'force-replace)
      (set-buffer-modified-p orig-buffer-modified-status)))

;; ----------
;; Based on idea from jwz@lucid.com.
(defun mail-add-x-taunt ()
  "Add an X windows taunt to your mail headers."
  (interactive)
  (let ((orig-buffer-modified-status (buffer-modified-p)))
    (mail-put-unique-header "X-Windows" 
                     (aref x-taunt-strings (% (logand (random) 65535) 
                                            (length x-taunt-strings)))
                   'force-replace)
    (set-buffer-modified-p orig-buffer-modified-status)))

;; ----------
;; Based on my own totally brain-damaged ideas.  In fact, this
;; function is what started it all.
(defun mail-add-zippy-quote ()
  "Yow!  Am I quoted in your email yet?"
  (interactive)
  (or (fboundp 'yow) (load "yow" t t))
  (let (pinhead-buffer 
        pinhead-quote
        (pinhead-header "X-Zippy-Says")
        (orig-buffer-modified-status (buffer-modified-p)))
    (save-excursion
      (setq pinhead-buffer (generate-new-buffer "*yow*"))
      (set-buffer pinhead-buffer)
      (insert (yow))
      (mail-frob-tmp-addition-buffer (length pinhead-header))
      (setq pinhead-quote (buffer-substring (point-min) (point-max)))
      (kill-buffer pinhead-buffer))
    (mail-put-unique-header pinhead-header pinhead-quote 'force-replace)
    (set-buffer-modified-p orig-buffer-modified-status)))

(defun mail-add-antipastobozoticataclysm ()
  "Add an X-Antipastobozoticataclysm header."
  (interactive)
  (let ((orig-buffer-modified-status (buffer-modified-p))
        (antipastobozoticataclysm-buffer
	 (generate-new-buffer "*Antipastobozoticataclysm-Buffer*"))
        (antipastobozoticataclysm-header "X-Antipastobozoticataclysm")
        antipastobozoticataclysm)
    (save-excursion
      (set-buffer antipastobozoticataclysm-buffer)
      (insert (aref antipastobozoticataclysm-strings
		    (% (logand (random) 65535)
		       (length antipastobozoticataclysm-strings))))
      (mail-frob-tmp-addition-buffer (length antipastobozoticataclysm-header))
      (setq antipastobozoticataclysm (buffer-substring (point-min)
						       (point-max)))
      (kill-buffer antipastobozoticataclysm-buffer))
    (mail-put-unique-header antipastobozoticataclysm-header
			    antipastobozoticataclysm 'force-replace)
    (set-buffer-modified-p orig-buffer-modified-status)))
  

;; From jimb@gnu.ai.mit.edu.  I haven't bothered to integrate this with the
;; rest of the code in any useful way because this program really needs a
;; total rewrite, and I just don't have time right now.  But I'm keeping
;; the messages here so I'll know where to find them.  --friedman 1994-06-26

(defconst emacs-threats
  '["because you deserve a brk today."
    "the definitive fritterware."
    "no job too big... no job."
    "the Swiss Army of Editors."
    "Lovecraft was an optimist."
    "because extension languages should come with the editor built in."
    "if it payed rent for disk space, you'd be rich."
    "a compelling argument for pencil and paper."
    "it's like swatting a fly with a supernova."
    "the road to Hell is paved with extensibility."
    "a learning curve that you can use as a plumb line."
    "more than just a Lisp interpreter, a text editor as well!"
    "freely redistributable; void where prohibited by law."
    "(setq software-quality (/ 1 number-of-authors))"
    "because idle RAM is the Devil's playground."
    "a Lisp interpreter masquerading as ... a Lisp interpreter!"
    "anything free is worth what you paid for it."
    "ballast for RAM."
    "you'll understand when you're older, dear."
    "the prosecution rests its case."
    "don't cry -- it won't help."
    "because one operating system isn't enough."
    "if SIGINT doesn't work, try a tranquilizer."
    "an inspiring example of form following function... to Hell."
    "because editing your files should be a traumatic experience."
    "or perhaps you'd prefer Russian Roulette, after all?"
    "it's all fun and games, until somebody tries to edit a file."
    "impress your (remaining) friends and neighbors."
    "because Hell was full."
    "where editing text is like playing Paganini on a glass harmonica."
    "the answer to the world surplus of CPU cycles."
    "don't try this at home, kids."]
  "Facts about Emacs that you and your loved ones should be aware of.")

(defconst x-threats
  '["a mistake carried out to perfection."
    "a moment of convenience, a lifetime of regret."
    "a terminal disease."
    "complex nonsolutions to simple nonproblems."
    "dissatisfaction guaranteed."
    "don't get frustrated without it."
    "even your dog won't like it."
    "flaky and built to stay that way."
    "flawed beyond belief."
    "foiled again."
    "form follows malfunction."
    "garbage at your fingertips."
    "ignorance is our most important resource."
    "it could be worse, but it'll take time."
    "it could happen to you."
    "let it get in *your* way."
    "live the nightmare."
    "more than enough rope."
    "never had it, never will."
    "no hardware is safe."
    "power tools for power fools."
    "power tools for power losers."
    "putting new limits on productivity."
    "simplicity made complex."
    "some voids are better left unfilled."
    "sometimes you fill a vacuum and it still sucks."
    "the art of incompetence."
    "the cutting edge of obsolescence."
    "the defacto substandard."
    "the first fully modular software disaster."
    "the joke that kills."
    "the problem for your problem."
    "there's got to be a better way."
    "warn your friends about it."
    "you'd better sit down."
    "you'll envy the dead."
    "graphics hacking :: Roman numerals : sqrt (pi)"]
  "What users said as they collapsed.")


(defun add-random-header (name table)
  (save-excursion
    (let ((modflag (buffer-modified-p)))
      (let ((message (aref table
                           (% (lsh (random t) -5)
                              (length table)))))
        (goto-char (point-min))
        (mail-position-on-field name)
        (insert message)
        (set-buffer-modified-p modflag)))))


;;; This ticks off Stephen Gildea.  If you're alienating cool people,
;;; why bother?
;;; Because cool people can take a crack at their own projects.  It's
;;; a sign of maturity.
(defun add-x-threat-header ()
  (add-random-header "X-Windows" x-threats))

(defun add-emacs-threat-header ()
  (add-random-header "Emacs" emacs-threats))

(defun add-tomato ()
  (add-random-header "Tomato" ["mauve"]))

(defun add-random-threat ()
  (let ((all-threats '[add-x-threat-header
                       add-emacs-threat-header
                       add-tomato]))
    (funcall (aref all-threats
                   (% (lsh (random t) -2)
                      (length all-threats))))))
    
(add-hook 'mail-setup-hook 'add-random-threat)


;; eof
