;;; zenirc-bork.el --- Swedish Chef message catalog for ZenIRC

;; Copyright (C) 1993, 1994 Ben A. Mesander

;; Author: Per Persson <pp@gnu.ai.mit.edu>
;; Maintainer: pp@gnu.ai.mit.edu
;; Keywords: extensions
;; Created: 95-07-28

;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, you can either send email to this
;; program's maintainer or write to: The Free Software Foundation,
;; Inc.; 675 Massachusetts Avenue; Cambridge, MA 02139, USA.

;;; Commentary:

;;;  "I am Svedish Chef of Burg. Prepaur to bey Assimilatedy."
;;;  "Borg borg borg!"

;;; Code:
(require 'zenirc)

(zenirc-lang-define-catalog
 'bork
 '((s001 . "[inffu] Yuoo ere-a vesteeng teeme-a. Bork Bork Bork!\n")
   (s002 . "[inffu] Yuoor IRC serfer is %s roonneeng ircd ferseeun %s\n")
   (s003 . "[inffu] Thees serfer ves creeted %s\n")
   (s200 . "[inffu] %s (%s) Leenk -> %s\n")
   (s202 . "[inffu] %s H.S. -> %s\n")
   (s203 . "[inffu] %s Hmmm -> IP eddress: %s\n")
   (s204 . "[inffu] %s Oper -> %s\n")
   (s205 . "[inffu] %s User -> %s\n")
   (s206 . "[inffu] %s Serf -> %s %s %s %s \n")
   (s208 . "[inffu] %s %s -> %s\n")
   (s209 . "[inffu] %s Cles -> %s = %s\n")
   (s211 . "[inffu] %s lenk up %s sec\nSent: %s/%s, Rcvd: %s/%s, SendQ: %s\n")
   (s212 . "[inffu] %s\t->\tteemes: %s\tbytes: %s\n")
   (s213 . "[inffu] C hst/nme/prt/cls: %s/%s/%s/%s\n")
   (s214 . "[inffu] N hst/nme/prt/cls: %s/%s/%s/%s\n")
   (s215 . "[inffu] %s hust/neme-a/cless:\t%s/%s/%s\n")
   (s216 . "[inffu] K hust/userneme-a:\t%s/%s\n")
   (s217 . "[inffu] Q %s/%s/%s/%s/%s\n")
   (s218 . "[inffu] Cless: %s Peeng freq: %s Conn.freq: %s Mex Leenks: %s Sendq: %s\n")
   (s219 . "[inffu] Ind ooff /stets.\n")
   (s221 . "[inffu] Yuoor coorrent user mude-a is: %s\n")
   (s241 . "[inffu] LEEF hustmesk/dept:\t\t%s/%s\n")
   (s242 . "[inffu] %s\n")
   (s243 . "[inffu] %s neeckneme-a/user@hust:\t%s/%s\n")
   (s244 . "[inffu] HOoB  hustmesk/serferneme-a:\t%s/%s\n")
   (s251 . "[inffu] Zeere-a ere-a %s/%s feesible-a/infeesible-a users oon %s serfers.\n")
   (s252 . "[inffu] Zeere-a ere-a %s mejur dveebs oonleene-a.\n")
   (s253 . "[inffu] Zeere-a ere-a %s unknoon cunnecshuns.\n")
   (s254 . "[inffu] Zeere-a ere-a %s chunnels\n")
   (s255 . "[inffu] Zeere-a ere-a %s cleeents und %s serfers cunnected tu thees serfer\n")
   (s256 . "[inffu] Edmeenistretife-a inffurmeshun fur %s:\n")
   (s257 . "[inffu] %s\n")
   (s258 . "[inffu] %s\n")
   (s259 . "[inffu] %s\n")
   (s261 . "[inffu] %s Feele-a -> %s %s\n")
   (s301 . "[inffu] %s is evey: %s\n")
   (s302 . "[inffu] userhust: %s\n")
   (s303 . "[inffu] Coorrently vesteeng teeme-a: %s\n")
   (s305 . "[inffu] Yuoo ere-a nu lunger evey\n")
   (s306 . "[inffu] Yuoo ere-a evey\n")
   (s311 . "[inffu] %s (%s@%s) is %s\n")
   (s312 . "[inffu] %s isves useeng serfer %s (%s)\n")
   (s313 . "[inffu] %s is a mejur dveeb.\n")
   (s314 . "[inffu] %s (%s@%s) ves %s\n")
   (s315 . "[inffu] Ind ooff /vhu.\n")
   (s317 . "[inffu] %s hes beee idle-a %s\n")
   (s318 . "[inffu] Ind ooff /vhuees.\n")
   (s319 . "[inffu] %s is on: %s\n")
   (s321 . "[inffu] Chunnel         Users Tupeec\n")
   (s322 . "[inffu] %-15s %-5s %s\n")
   (s323 . "[inffu] Ind ooff /leest.\n")
   (s324 . "[inffu] Mude-a fur %s is %s %s\n")
   (s331 . "[inffu] %s hes nu tupeec\n")
   (s332 . "[inffu] %s tupeec: %s\n")
   (s333 . "[inffu] %s tupeec set by %s et %s\n")
   (s341 . "[inffu] Yuoo ere-a infeeting %s tu %s\n")
   (s342 . "[inffu] Yuoo ere-a eskeeng %s tu veste-a teeme-a\n")
   (s351 . "[inffu] Ferseeun: %s %s %s\n")
   (s352_header . "[inffu] Neeckneme-a  Stet Neme-a ooff Chunnel User@hust (Hup cuoont  Neme-a)\n")
   (s352 . "[inffu] %-9s %-3s  %-15s %s@%s (%s)\n")
   (s353 . "[inffu] Users on %s: %s\n")
   (s364 . "[inffu] %s %s %s\n")      
   (s365 . "[inffu] Ind ooff /leenks\n")
   (s367 . "[inffu] %s bun %s\n")     
   (s368 . "[inffu] Ind ooff bunleest\n")
   (s371 . "[inffu] %s\n")            
   (s372 . "[motd] %s\n")		
   (s375 . "[motd] Messege-a Ooff Zee Dey:\n")
   (s376 . "[motd] End ooff mutd\n")
   (s381 . "[inffu] You are now a major dweeb\n")
   (s382 . "[inffu] Rehesheeng: %s\n")
   (s391 . "[inffu] Teeme-a fur serfer %s: %s\n")
   (s392 . "[inffu] Usereed  Termeenel  Hust\n")
   (s393 . "[inffu] %s\n")
   (s395 . "[inffu] Nubudy lugged oon\n")
   (s401 . "[inffu] Nu sooch neeck/chunnel: %s\n")
   (s402 . "[inffu] Nu sooch serfer: %s\n")
   (s403 . "[inffu] Noo suuch choonnel: %s\n")
   (s404 . "[inffu] Yuoo cunnut send tu %s.\n")
   (s405 . "[inffu] Tuu muny chunnels: %s\n")
   (s406 . "[inffu] Serfer hes nu recurd ooff neeckneme-a: %s\n")
   (s407 . "[inffu] Doopleecete-a receepients. Nu messege-a sent: %s\n")
   (s409 . "[inffu] Nu ooreegin speceeffied.\n")
   (s411 . "[inffu] Nu receepient geefee.\n")
   (s412 . "[inffu] Nu text tu send.\n")
   (s413 . "[inffu] Nu tuplefel dumeeen: %s\n")
   (s414 . "[inffu] Veeldcerd in tuplefel dumeeen: %s\n")
   (s421 . "[inffu] Thees luuks leeke-a spem tu me-a: %s.  Bork Bork Bork!\n")
   (s422 . "[inffu] Nu mutd (fleme-a mejur dveeb leested in /edmeen)\n")
   (s423 . "[inffu] Nu edmeen inffu.  Ignurunt mejur dveeb roonneeng serfer.\n")
   (s431 . "[inffu] Nu neeckneme-a geefee\n")
   (s432 . "[inffu] Infeleed neeckneme-a: %s\n")
   (s433 . "[inffu] Neeckneme-a elreedy in use-a: %s\n")
   (s436 . "[inffu] Neeck culleesiun keell: %s\n")
   (s441 . "[inffu] %s is nut oon %s\n")
   (s442 . "[inffu] Yuoo ere-a nut oon %s.\n")
   (s443 . "[inffu] %s is elreedy oon chunnel %s.\n")
   (s444 . "[inffu] %s is nut lugged in\n")
   (s445 . "[inffu] Sume-a mejur dveeb vun't let yuoo du soommun\n")
   (s446 . "[inffu] Sume-a mejur dveeb vun't let yuoo du /users\n")
   (s451 . "[inffu] Yuoo hefe-a nut regeestered\n")
   (s461 . "[inffu] Nut inuoogh peremeters: %s\n")
   (s462 . "[inffu] Yuoo mey nut reregeester\n")
   (s463 . "[inffu] Sume-a fesceest mejur dveeb veell nut let yuoo cunnect\n")
   (s464 . "[inffu] Pessvurd is incurrect\n")
   (s465 . "[inffu] Yuoo ere-a nut ellooed tu use-a thees serfer.\n")
   (s467 . "[inffu] Key fur %s is elreedy set.\n")
   (s471 . "[inffu] Cunnut jueen %s (user leemit reeched).\n")
   (s472 . "[inffu] s is un unknoon mude-a cherecter.\n")
   (s473 . "[inffu] Cunnut jueen %s (infeete-a oonly).\n")
   (s474 . "[inffu] Cunnut jueen %s (bun).\n")
   (s475 . "[inffu] Cunnut jueen %s (chunnel key).\n")
   (s481 . "[inffu] Yuoo ere-a nut a beeg inuoogh dveeb tu du thet.\n")
   (s482 . "[inffu] Yuoo ere-a nut a pooermunger fur %s.\n")
   (s483 . "[inffu] Dooh. Yuoo cunnut keell a serfer\n")
   (s491 . "[inffu] Nu mejur dveebs ellooed frum yuoor hust\n")
   (s501 . "[inffu] Unknoon user mude-a fleg\n")
   (s502 . "[inffu] Cunnut chunge-a mude-a fur oozeer users\n")
   (action . "(sent tu %s)\n")
   (action-echo . "(sent tu %s)")
   (connect-failed . "[irrur] Cuooldn't cunnect tu %s purt %d, reesun: %s\n")
   (connect-try . "[inffu] Cunnecteeng tu %s purt %d...\n")
   (connect-abort . "[inffu] Eburted ettempt tu cunnect tu un irc serfer.\n")
   (ctcp_action . "[ecshun->%s] %s %s\n") ; ctcp ACTION display
   (ctcp_clientinffu . "[qooery] CLIENTINFO frum %s tu %s\n")
   (ctcp_errmsg . "[qooery] IRRMSG frum %s tu %s\n")
   (ctcp_finger . "[qooery] FINGER frum %s tu %s\n")
   (ctcp_ping . "[qooery] PING frum %s tu %s\n")
   (ctcp_ping_reply . "[reply] PING: %s is %s secunds evey\n")
   (ctcp_source . "[qooery] SOOoRCE frum %s tu %s\n")
   (ctcp_time . "[qooery] TIME frum %s tu %s\n")
   (ctcp_userinffu . "[qooery] USERINFFU from %s to %s\n")
   (ctcp_version . "[qooery] FERSION frum %s tu %s\n")
   (debug  . "[debug] %s\n")
   (error . "[%s] %s\n")
   (invite . "[inffu] %s infeetes yuoo tu %s.\n")
   (join_you . "[inffu] Jueening chunnel: %s\n")
   (join . "[inffu] %s hes jueened %s\n")
   (kick . "[inffu] %s hes beee keecked frum %s by %s\n")
   (kick_you . "[inffu] Yuoo hefe-a beee keecked frum %s by %s\n")
   (kill . "[inffu] Yuoo hefe-a beee keelled: %s")
   (mode . "[inffu] %s hes chunged mude-a fur %s: %s\n")
   (nick . "[inffu] %s hes chunged neeck tu %s\n")
   (newcatalog . "[inffu] Coorrent messege-a cetelug set tu %s\n")
   (nocatalog . "[error] Nu messege-a cetelug deffeened fur %s\n")
   (nosend . "[inffu] yuoo hefe-a nu coorrent feectim tu send tu\n")
   (notice . "{%s%s} %s\n")
   (notice_you . "{%s} %s\n")
   (now_qooerying . "[inffu] Coorrent feectim is %s.\n")
   (part_you . "[inffu] Leefeeng: %s (%s)\n") ; your part from channel message
   (part . "[inffu] %s hes lefft %s (%s)\n")
   (pong . "[inffu] %s seys oojnk\n")
   (privmsg . "<%s%s> %s\n")
   (privmsg_you . "*%s* %s\n")
   (protocol_violation . "[irrur] Zee fullooeeng leene-a is in feeuleshun ooff zee IRC prutucul.\n[irrur] Pleese-a tell zee serfer edmeenistretur:\n%s: %s\n")
   (query . "[qooery] frum %s tu %s cuntent %s\n")
   (qyery_unknown . "is un unknoon CTCP qooery")
   (query_unbalanced . "[UNBALANCED qooery] um %s tu %s cuntent %s\n")
   (query_unbalanced_reply . "is un unbelunced CTCP quuery")
   (quit . "[inffu] %s stupped vesteeng teeme-a: %s\n")
   (reply . "[reply] frum %s tu %s cuntent %s\n")
   (reply_unbalanced . "[UNBELENCED reply] frum %s tu %s cuntent %s\n")
   (send . "(sent tu %s)\n")
   (send-echo . "(sent tu %s)")
   (send-multi . "(sent tu %s in %d perts)\n")
   (send-multi-echo . "(sent tu %s in %d perts)")
   (sentinel . "\nZenIRC inded et %s\n")
   (server . "[serfer] %s\n")
   (signal . "[seegnel in %s]")
   (topic . "[inffu] %s chunged zee tupeec oon %s tu: %s\n")
   (wallops . "-%s- %s\n")
   ))

(provide 'zenirc-bork)

;;; zenirc-bork.el ends here
